// Code generated by ent, DO NOT EDIT.

package chatroom

import (
	"gochassis/ent/predicate"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLTE(FieldID, id))
}

// RoomName applies equality check predicate on the "room_name" field. It's identical to RoomNameEQ.
func RoomName(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldRoomName, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldDeletedAt, v))
}

// RoomNameEQ applies the EQ predicate on the "room_name" field.
func RoomNameEQ(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldRoomName, v))
}

// RoomNameNEQ applies the NEQ predicate on the "room_name" field.
func RoomNameNEQ(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNEQ(FieldRoomName, v))
}

// RoomNameIn applies the In predicate on the "room_name" field.
func RoomNameIn(vs ...string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIn(FieldRoomName, vs...))
}

// RoomNameNotIn applies the NotIn predicate on the "room_name" field.
func RoomNameNotIn(vs ...string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotIn(FieldRoomName, vs...))
}

// RoomNameGT applies the GT predicate on the "room_name" field.
func RoomNameGT(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGT(FieldRoomName, v))
}

// RoomNameGTE applies the GTE predicate on the "room_name" field.
func RoomNameGTE(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGTE(FieldRoomName, v))
}

// RoomNameLT applies the LT predicate on the "room_name" field.
func RoomNameLT(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLT(FieldRoomName, v))
}

// RoomNameLTE applies the LTE predicate on the "room_name" field.
func RoomNameLTE(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLTE(FieldRoomName, v))
}

// RoomNameContains applies the Contains predicate on the "room_name" field.
func RoomNameContains(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldContains(FieldRoomName, v))
}

// RoomNameHasPrefix applies the HasPrefix predicate on the "room_name" field.
func RoomNameHasPrefix(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldHasPrefix(FieldRoomName, v))
}

// RoomNameHasSuffix applies the HasSuffix predicate on the "room_name" field.
func RoomNameHasSuffix(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldHasSuffix(FieldRoomName, v))
}

// RoomNameEqualFold applies the EqualFold predicate on the "room_name" field.
func RoomNameEqualFold(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEqualFold(FieldRoomName, v))
}

// RoomNameContainsFold applies the ContainsFold predicate on the "room_name" field.
func RoomNameContainsFold(v string) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldContainsFold(FieldRoomName, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.ChatRoom {
	return predicate.ChatRoom(sql.FieldNotNull(FieldDeletedAt))
}

// HasPost applies the HasEdge predicate on the "post" edge.
func HasPost() predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, PostTable, PostColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasPostWith applies the HasEdge predicate on the "post" edge with a given conditions (other predicates).
func HasPostWith(preds ...predicate.Post) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := newPostStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasChats applies the HasEdge predicate on the "chats" edge.
func HasChats() predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, ChatsTable, ChatsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasChatsWith applies the HasEdge predicate on the "chats" edge with a given conditions (other predicates).
func HasChatsWith(preds ...predicate.Chat) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := newChatsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasProfiles applies the HasEdge predicate on the "profiles" edge.
func HasProfiles() predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, ProfilesTable, ProfilesPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasProfilesWith applies the HasEdge predicate on the "profiles" edge with a given conditions (other predicates).
func HasProfilesWith(preds ...predicate.Profile) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		step := newProfilesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.ChatRoom) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.ChatRoom) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.ChatRoom) predicate.ChatRoom {
	return predicate.ChatRoom(func(s *sql.Selector) {
		p(s.Not())
	})
}
